// HORB
// Class: Test_Proxy
// Version: 0.0
// Date: Fri Oct 13 13:19:19 JST 2000
// Generator: HORBC Compiler 2.0..1
//
import horb.orb.*;
import java.io.*;

public  class Test_Proxy  implements horb.orb.Proxy {
  protected short classNo;
  public final static short major = 0;
  public final static short minor = 0;
  public short _getMajorVersion() { return major;}
  public short _getMinorVersion() { return minor;}
  protected HorbURL url;
  private transient IOCI ioci;
  public IOCI _getIOCI() { return ioci; }
  public void _setIOCI(IOCI ioci) { this.ioci = ioci; }
  public HorbURL _getObjectURL() { return url; }
  public Test_Proxy() {
    classNo = 1;
  }
  public synchronized void _connect(HorbURL url, String user, String passwd) throws HORBException {
    try {
      if (ioci == null)
        ioci = (HORB.getFactory(url.getProtocol())).createIOCI();
    } catch (Exception e) {
      throw new HORBException("can't create IOCI: "+e);
    }
    this.url = ioci.connect(url, "Test",major, minor, user, passwd, horb.orb.transport.HORBSession.MULTIPLE, null);
  }
  public synchronized void _release() {
    ioci.releaseObject();
    ioci = null;
  }
  public Test_Proxy(HorbURL url) throws HORBException {
    this(url, null, null);
  }
  public Test_Proxy(String surl) throws HORBException {
    this(new HorbURL(surl), null, null);
  }
  public Test_Proxy(HorbURL url, String user, String passwd) throws HORBException {
    this();
    try{
    _connect(url, user, passwd);
    } catch(RemoteException re) {
      IOCI io = _getIOCI();
      Throwable e = null;
      try {
        e = io.recvException();
      } catch (IOException ioe) {
        throw new NetException(ioe);
      }
      if (e == null)
      throw new RemoteException("remote exception occured.");
      throw new RemoteException(e.toString());
    }
  }
  public java.lang.String greeting(java.lang.String arg0)  {
    IOCI io = _getIOCI();
    try {
    io.methodStart();
    io.selectMethod(classNo, 1001);
    io.sendString(arg0);
    io.kick();
    } catch (IOException ioe) {
      io.methodEnd();
      throw new NetException(ioe);
    }
    try {
    short stat = io.recvStatus();
    java.lang.String retValue;
    retValue = io.recvString();
    return retValue;
    } catch(RemoteException re) {
      Throwable e = null;
      try {
        e = io.recvException();
      } catch (IOException ioe) {
        throw new NetException(ioe);
      }
      if (e == null)
      throw new RemoteException("remote exception occured.");
      throw new RemoteException(e.toString());
    } catch (IOException ioe) {
      throw new NetException(ioe);
    }finally {
      io.methodEnd();
    }
  }
  public void _sendInstance(IOCI io, Object obj, Loopy loopy, byte place) throws HORBException, IOException {
  }
  public Object _recvInstance(IOCI io, Object obj, boolean superclass, Goldberg gb, byte place) throws HORBException, IOException {
    Test o = null;
    if (superclass) {
      o = (Test)obj;
    } else {
      try {
        o = new Test();
      } catch(Throwable t) {
        throw new HORBException("Exception occured during receiving an object: "+t);
      }
      gb.put(o);
    }
    return (Object)o;
  }
   private void readObject(java.io.ObjectInputStream in)
      throws IOException, ClassNotFoundException {
         in.defaultReadObject();
         if ( in instanceof horb.orb.transport.HORBObjectInputStream )
            this._connect( this.url, 
               ((horb.orb.transport.HORBObjectInputStream)in).username,
               ((horb.orb.transport.HORBObjectInputStream)in).passwd );
         else
            this._connect( this.url,"", "" );
   }
  public boolean equals(Object o){
    if (this == o) return true;
    if (o instanceof Test_Proxy) { /* uses toString() to compares */
      return this.toString().equals(o.toString());
    }
    else if (o instanceof Test) {
      return o.equals(this);
    }
    return false;
  }
  public int hashCode(){ /* return remote object's hashCode() */
    if (url != null) {
      return url.getObjectHashCode();
    }
    return super.hashCode();
  }
  public String toString() { /* return "<host>:<host's processID>:<objectID>" */
    if (url != null) {
      return url.getObjectHostAddress()+":"+url.getObjectProcessID()+":"+url.getObjectID();
    }
    return super.toString();
  }
  public boolean _available() { return false; }
  public synchronized boolean _wait(long timeout) throws InterruptedException { return false; }
  public void _setHandler(AsyncMethodHandler handler, int tag) {}
  private static String[][] methodInfo = {
    {"java.lang.String", "greeting", "java.lang.String", "1001"},
    {"", "Test", "void", "1000"},
  };
  public static String[][] getMethodInfo(){
    return methodInfo;
  }
}
